Index: XIOS3/trunk/src/transport/legacy_context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_client.cpp	(revision 2546)
+++ XIOS3/trunk/src/transport/legacy_context_client.cpp	(revision 2547)
@@ -24,5 +24,5 @@
     \param [in] intraComm_ communicator of group client
     \param [in] interComm_ communicator of group server
-    \cxtSer [in] cxtSer Pointer to context of server side. (It is only used in case of attached mode).
+    \cxtSer [in] cxtSer Pointer to context of server side. (It is only used in case of attached mode --> obsolete).
     */
     CLegacyContextClient::CLegacyContextClient(CContext* parent, MPI_Comm intraComm_, MPI_Comm interComm_, CContext* cxtSer)
@@ -31,11 +31,7 @@
     {
       pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
-      if (isAttachedModeEnabled()) pureOneSided=false ; // no one sided in attach mode
-
-      if (!isAttachedModeEnabled()) MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
-      else interCommMerged_ = interComm_; // interComm_ is yet an intracommunicator in attached
-      
+      MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
       MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
-
+      eventScheduler_ = parent->getEventScheduler() ;  
       timeLine = 1;
     }
@@ -44,5 +40,4 @@
 
     /*!
-    In case of attached mode, the current context must be reset to context for client
     \param [in] event Event sent to server
     */
@@ -105,24 +100,5 @@
       }
       
-      if (isAttachedModeEnabled()) // couldBuffer is always true in attached mode
-      {
-        while (checkBuffers(ranks)) callGlobalEventLoop() ;
-      
-        CXios::getDaemonsManager()->scheduleContext(hashId_) ;
-        while (CXios::getDaemonsManager()->isScheduledContext(hashId_)) callGlobalEventLoop() ;
-      }
-      
-      MPI_Request req ;
-      MPI_Status status ;
-      MPI_Ibarrier(intraComm,&req) ;
-      int flag ;
-      MPI_Test(&req,&flag,&status) ;
-      while(!flag) 
-      {
-        callGlobalEventLoop() ;
-        MPI_Test(&req,&flag,&status) ;
-      }
-
-
+      synchronize() ;
       timeLine++;
     }
@@ -148,5 +124,5 @@
       list<CClientBuffer*>::iterator itBuffer;
       bool areBuffersFree;
-     
+/*     
       for (itServer = serverList.begin(); itServer != serverList.end(); itServer++)
       {
@@ -156,12 +132,39 @@
           CTokenManager* tokenManager = CXios::getRessourcesManager()->getTokenManager() ;
           size_t token = tokenManager->getToken() ;
-          while (!tokenManager->lockToken(token)) callGlobalEventLoop() ;
+          while (!tokenManager->checkToken(token)) callGlobalEventLoop() ;
           newBuffer(*itServer);
           it = buffers.find(*itServer);
           checkAttachWindows(it->second,it->first) ;
-          tokenManager->unlockToken(token) ;
+          tokenManager->updateToken(token) ;
         }
         bufferList.push_back(it->second);
       }
+*/
+      map<int,MPI_Request> attachList ;
+     
+      for (itServer = serverList.begin(); itServer != serverList.end(); itServer++)
+      {
+        it = buffers.find(*itServer);
+        if (it == buffers.end())
+        {
+          newBuffer(*itServer);
+          it = buffers.find(*itServer);
+          checkAttachWindows(it->second, it->first, attachList) ;
+        }
+        bufferList.push_back(it->second);
+      }
+      
+      while(!attachList.empty())
+      {
+        auto it = attachList.begin() ;
+        while(it!=attachList.end())
+        {
+          if (checkAttachWindows(buffers[it->first], it->first, attachList)) it=attachList.erase(it) ;
+          else ++it ;
+        }
+
+        yield() ;
+      }
+
 
       double lastTimeBuffersNotFree=0. ;
@@ -193,5 +196,5 @@
           checkBuffers();
 
-          callGlobalEventLoop() ;
+          yield() ;
         }
 
@@ -203,4 +206,56 @@
    }
 
+
+   bool CLegacyContextClient::checkAttachWindows(CClientBuffer* buffer, int rank, map<int, MPI_Request>& attachList)
+   {
+      int dummy;
+      bool ret=true; 
+
+      if (!buffer->isAttachedWindows())
+      {
+           // create windows dynamically for one-sided
+          /*
+          CTimer::get("create Windows").resume() ;
+          MPI_Comm interComm ;
+          int tag = 0 ;
+          MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, tag, &interComm) ;
+          MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
+          MPI_Comm_free(&interComm) ;
+                
+          buffer->attachWindows(winComm_[rank]) ;
+          CXios::getMpiGarbageCollector().registerCommunicator(winComm_[rank]) ;
+          MPI_Barrier(winComm_[rank]) ;
+        */
+        if (attachList.count(rank)==0) 
+        {
+          MPI_Irecv(&dummy,0,MPI_INT,clientSize+rank, 21, interCommMerged_, &attachList[rank]) ;
+          ret = false ;
+        }
+        else
+        {
+          MPI_Status status ;
+          int flag ;
+          MPI_Test(&attachList[rank],&flag, &status) ;
+          if (flag)
+          {
+            CTimer::get("create Windows").resume() ;
+            MPI_Comm interComm ;
+            int tag = 0 ;
+            MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, tag, &interComm) ;
+            MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
+            MPI_Comm_free(&interComm) ;
+              
+            buffer->attachWindows(winComm_[rank]) ;
+            CXios::getMpiGarbageCollector().registerCommunicator(winComm_[rank]) ;
+            MPI_Barrier(winComm_[rank]) ;
+            ret = true ;
+          }
+          else ret=false ;
+        }
+      }
+      return ret ;
+    }
+
+
    void CLegacyContextClient::eventLoop(void)
    {
@@ -211,6 +266,23 @@
    {
      locked_=true ;
-     context_->globalEventLoop() ;
+     context_->yield() ;
      locked_=false ;
+   }
+
+   void CLegacyContextClient::yield(void)
+   {
+     locked_=true ;
+     context_->yield() ;
+     locked_=false ;
+   }
+
+   void CLegacyContextClient::synchronize(void)
+   {
+     if (context_->getServiceType()!=CServicesManager::CLIENT)
+     {
+       locked_=true ;
+       context_->synchronize() ;
+       locked_=false ;
+     }    
    }
    /*!
@@ -226,90 +298,23 @@
         maxEventSizes[rank] = CXios::minBufferSize;
       }
-      
-      int considerServers = 1;
-      if (isAttachedModeEnabled()) considerServers = 0;
-      CClientBuffer* buffer = buffers[rank] = new CClientBuffer(interCommMerged_, considerServers*clientSize+rank, mapBufferSize_[rank], maxEventSizes[rank]);
+      bool hasWindows = true ;
+      CClientBuffer* buffer = buffers[rank] = new CClientBuffer(interCommMerged_, clientSize+rank, mapBufferSize_[rank], hasWindows);
       if (isGrowableBuffer_) buffer->setGrowableBuffer(1.2) ;
       else buffer->fixBuffer() ;
       // Notify the server
+     
       CBufferOut* bufOut = buffer->getBuffer(0, 4*sizeof(MPI_Aint));
       MPI_Aint sendBuff[4] ;
       sendBuff[0]=hashId_;
       sendBuff[1]=mapBufferSize_[rank];
-      sendBuff[2]=buffers[rank]->getWinAddress(0); 
-      sendBuff[3]=buffers[rank]->getWinAddress(1); 
-      info(100)<<"CLegacyContextClient::newBuffer : rank "<<rank<<" winAdress[0] "<<buffers[rank]->getWinAddress(0)<<" winAdress[1] "<<buffers[rank]->getWinAddress(1)<<endl;
-      bufOut->put(sendBuff, 4); 
+      sendBuff[2]=buffers[rank]->getWinBufferAddress(0); 
+      sendBuff[3]=buffers[rank]->getWinBufferAddress(1); 
+      info(100)<<"CLegacyContextClient::newBuffer : rank "<<rank<<" winAdress[0] "<<buffers[rank]->getWinBufferAddress(0)<<" winAdress[1] "<<buffers[rank]->getWinBufferAddress(1)<<endl;
+      bufOut->put(sendBuff,4); 
       buffer->checkBuffer(true);
-/*
-       // create windows dynamically for one-sided
-      if (!isAttachedModeEnabled())
-      { 
-        CTimer::get("create Windows").resume() ;
-        MPI_Comm interComm ;
-        MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, 0, &interComm) ;
-        MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
-        CXios::getMpiGarbageCollector().registerCommunicator(winComm_[rank]) ;
-        MPI_Comm_free(&interComm) ;
-        windows_[rank].resize(2) ;
-        
-        MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][0]);
-        CXios::getMpiGarbageCollector().registerWindow(windows_[rank][0]) ;
-        
-        MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][1]);   
-        CXios::getMpiGarbageCollector().registerWindow(windows_[rank][1]) ;
-
-        CTimer::get("create Windows").suspend() ;
-      }
-      else
-      {
-        winComm_[rank] = MPI_COMM_NULL ;
-        windows_[rank].resize(2) ;
-        windows_[rank][0] = MPI_WIN_NULL ;
-        windows_[rank][1] = MPI_WIN_NULL ;
-      }
-      buffer->attachWindows(windows_[rank]) ;
-      if (!isAttachedModeEnabled()) MPI_Barrier(winComm_[rank]) ;
-  */     
-   }
-
-   void CLegacyContextClient::checkAttachWindows(CClientBuffer* buffer, int rank)
-   {
-      if (!buffer->isAttachedWindows())
-      {
-           // create windows dynamically for one-sided
-        if (!isAttachedModeEnabled())
-        { 
-          CTimer::get("create Windows").resume() ;
-          MPI_Comm interComm ;
-          MPI_Intercomm_create(commSelf_, 0, interCommMerged_, clientSize+rank, 0, &interComm) ;
-          MPI_Intercomm_merge(interComm, false, &winComm_[rank]) ;
-          CXios::getMpiGarbageCollector().registerCommunicator(winComm_[rank]) ;
-          MPI_Comm_free(&interComm) ;
-          windows_[rank].resize(2) ;
-      
-          MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][0]);
-          CXios::getMpiGarbageCollector().registerWindow(windows_[rank][0]) ;
-      
-          MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][1]);   
-          CXios::getMpiGarbageCollector().registerWindow(windows_[rank][1]) ;
-
-          CTimer::get("create Windows").suspend() ;
-          buffer->attachWindows(windows_[rank]) ;
-          MPI_Barrier(winComm_[rank]) ;
-        }
-        else
-        {
-          winComm_[rank] = MPI_COMM_NULL ;
-          windows_[rank].resize(2) ;
-          windows_[rank][0] = MPI_WIN_NULL ;
-          windows_[rank][1] = MPI_WIN_NULL ;
-          buffer->attachWindows(windows_[rank]) ;
-        }
-
-      }
-    }
-
-
+
+   }
+
+  
   
    /*!
@@ -336,16 +341,8 @@
       buffers.clear();
 
-// don't know when release windows
-
-      //if (!isAttachedModeEnabled())
-      //{  
-      //  for(auto& it : winComm_)
-      //  {
-      //    int rank = it.first ;
-      //    MPI_Win_free(&windows_[rank][0]);
-      //    MPI_Win_free(&windows_[rank][1]);
-      //    MPI_Comm_free(&winComm_[rank]) ;
-      //  }
-      //} 
+      for(auto& it : winComm_)
+      {
+        int rank = it.first ;
+      }
    }
 
@@ -469,6 +466,4 @@
   bool CLegacyContextClient::isNotifiedFinalized(void)
   {
-    if (isAttachedModeEnabled()) return true ;
-
     bool finalized = true;
     map<int,CClientBuffer*>::iterator itBuff;
Index: XIOS3/trunk/src/transport/legacy_context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_client.hpp	(revision 2546)
+++ XIOS3/trunk/src/transport/legacy_context_client.hpp	(revision 2547)
@@ -11,4 +11,5 @@
 #include "registry.hpp"
 #include "context_client.hpp"
+#include "window_dynamic.hpp"
 
 namespace xios
@@ -48,8 +49,10 @@
       void getBuffers(const size_t timeLine, const list<int>& serverList, const list<int>& sizeList, list<CBufferOut*>& retBuffers);
       void newBuffer(int rank);
-      void checkAttachWindows(CClientBuffer* buffer , int rank) ;
+      bool checkAttachWindows(CClientBuffer* buffer , int rank, map<int,MPI_Request>& attachList) ;
       bool checkBuffers(list<int>& ranks);
       bool checkBuffers(void);
       void callGlobalEventLoop() ;
+      void yield(void) ;
+      void synchronize(void) ;
       bool havePendingRequests(list<int>& ranks) ;
       void setGrowableBuffer(void) { isGrowableBuffer_=true;}
@@ -76,5 +79,5 @@
 
       std::map<int, MPI_Comm> winComm_ ; //! Window communicators
-      std::map<int, std::vector<MPI_Win> >windows_ ; //! one sided mpi windows to expose client buffers to servers == windows[nbServers][2]
+      std::map<int, std::vector<CWindowDynamic*> >windows_ ; //! one sided mpi windows to expose client buffers to servers == windows[nbServers][2]
       bool isGrowableBuffer_ = true ;
 
@@ -82,4 +85,5 @@
 
       bool locked_ = false ; //!< The context client is locked to avoid recursive checkBuffer
+      shared_ptr<CEventScheduler> eventScheduler_ ;
   };
 }
Index: XIOS3/trunk/src/transport/legacy_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_server.cpp	(revision 2546)
+++ XIOS3/trunk/src/transport/legacy_context_server.cpp	(revision 2547)
@@ -43,6 +43,5 @@
     finished=false;
 
-    if (!isAttachedModeEnabled()) MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
-    else interCommMerged_ = interComm_; // interComm_ is yet an intracommunicator in attached
+    MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
     MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
     
@@ -50,6 +49,4 @@
 
     pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
-    if (isAttachedModeEnabled()) pureOneSided=false ; // no one sided in attach mode
-      
   }
  
@@ -115,34 +112,33 @@
       remoteHashId_ = recvBuff[0] ;
       StdSize buffSize = recvBuff[1];
-      vector<MPI_Aint> winAdress(2) ;
-      winAdress[0]=recvBuff[2] ; winAdress[1]=recvBuff[3] ;
+      vector<MPI_Aint> winBufferAddress(2) ;
+      winBufferAddress[0]=recvBuff[2] ; winBufferAddress[1]=recvBuff[3] ;
       mapBufferSize_.insert(std::make_pair(rank, buffSize));
 
       // create windows dynamically for one-sided
-      if (!isAttachedModeEnabled())
-      { 
-        CTimer::get("create Windows").resume() ;
-        MPI_Comm interComm ;
-        MPI_Intercomm_create(commSelf_, 0, interCommMerged_, rank, 0 , &interComm) ;
-        MPI_Intercomm_merge(interComm, true, &winComm_[rank]) ;
-        CXios::getMpiGarbageCollector().registerCommunicator(winComm_[rank]) ;
-        MPI_Comm_free(&interComm) ;
-        windows_[rank].resize(2) ;
-        MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][0]);
-        CXios::getMpiGarbageCollector().registerWindow(windows_[rank][0]) ;
-        MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][1]);
-        CXios::getMpiGarbageCollector().registerWindow(windows_[rank][1]) ;
-        CTimer::get("create Windows").suspend() ;
-        MPI_Barrier(winComm_[rank]) ;
-      }
-      else
-      {
-        winComm_[rank] = MPI_COMM_NULL ;
-        windows_[rank].resize(2) ;
-        windows_[rank][0] = MPI_WIN_NULL ;
-        windows_[rank][1] = MPI_WIN_NULL ;
-      }   
-
-      it=(buffers.insert(pair<int,CServerBuffer*>(rank,new CServerBuffer(windows_[rank], winAdress, 0, buffSize)))).first;
+      int dummy ;
+      MPI_Send(&dummy, 0, MPI_INT, rank, 21,interCommMerged_) ;
+      CTimer::get("create Windows").resume() ;
+      MPI_Comm interComm ;
+      int tag = 0 ;
+      MPI_Intercomm_create(commSelf_, 0, interCommMerged_, rank, tag , &interComm) ;
+      MPI_Intercomm_merge(interComm, true, &winComm_[rank]) ;
+      MPI_Comm_free(&interComm) ;
+      windows_[rank].resize(2) ;
+      //MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][0]);
+      //CXios::getMpiGarbageCollector().registerWindow(windows_[rank][0]) ;
+      //MPI_Win_create_dynamic(MPI_INFO_NULL, winComm_[rank], &windows_[rank][1]);
+      //CXios::getMpiGarbageCollector().registerWindow(windows_[rank][1]) ;
+      windows_[rank][0] = new CWindowDynamic() ;
+      windows_[rank][1] = new CWindowDynamic() ;
+      windows_[rank][0] -> create(winComm_[rank]) ;
+      windows_[rank][1] -> create(winComm_[rank]) ;
+      windows_[rank][0] -> setWinBufferAddress(winBufferAddress[0],0) ;
+      windows_[rank][1] -> setWinBufferAddress(winBufferAddress[1],0) ;
+      CTimer::get("create Windows").suspend() ;
+      CXios::getMpiGarbageCollector().registerCommunicator(winComm_[rank]) ;
+      MPI_Barrier(winComm_[rank]) ;
+
+      it=(buffers.insert(pair<int,CServerBuffer*>(rank,new CServerBuffer(windows_[rank], winBufferAddress, 0, buffSize)))).first;
       lastTimeLine[rank]=0 ;
       itLastTimeLine=lastTimeLine.begin() ;
@@ -230,20 +226,18 @@
   {
     CTimer::get("CLegacyContextServer::getBufferFromClient").resume() ;
-    if (!isAttachedModeEnabled()) // one sided desactivated in attached mode
-    {  
-      int rank ;
-      char *buffer ;
-      size_t count ; 
-
-      if (itLastTimeLine==lastTimeLine.end()) itLastTimeLine=lastTimeLine.begin() ;
-      for(;itLastTimeLine!=lastTimeLine.end();++itLastTimeLine)
-      {
-        rank=itLastTimeLine->first ;
-        if (itLastTimeLine->second < timeLine &&  pendingRequest.count(rank)==0 && buffers[rank]->isBufferEmpty())
-        {
-          if (buffers[rank]->getBufferFromClient(timeLine, buffer, count)) processRequest(rank, buffer, count);
-          if (count >= 0) ++itLastTimeLine ;
-          break ;
-        }
+
+    int rank ;
+    char *buffer ;
+    size_t count ; 
+
+    if (itLastTimeLine==lastTimeLine.end()) itLastTimeLine=lastTimeLine.begin() ;
+    for(;itLastTimeLine!=lastTimeLine.end();++itLastTimeLine)
+    {
+      rank=itLastTimeLine->first ;
+      if (itLastTimeLine->second < timeLine &&  pendingRequest.count(rank)==0 && buffers[rank]->isBufferEmpty())
+      {
+        if (buffers[rank]->getBufferFromClient(timeLine, buffer, count)) processRequest(rank, buffer, count);
+        if (count >= 0) ++itLastTimeLine ;
+        break ;
       }
     }
@@ -280,11 +274,13 @@
       {
         size_t newSize ;
-        vector<MPI_Aint> winAdress(2) ;
-        newBuffer>>newSize>>winAdress[0]>>winAdress[1] ;
+        vector<MPI_Aint> winBufferAdress(2) ;
+        newBuffer>>newSize>>winBufferAdress[0]>>winBufferAdress[1] ;
         buffers[rank]->freeBuffer(count) ;
         delete buffers[rank] ;
-        buffers[rank] = new CServerBuffer(windows_[rank], winAdress, 0, newSize) ;
+        windows_[rank][0] -> setWinBufferAddress(winBufferAdress[0],0) ;
+        windows_[rank][1] -> setWinBufferAddress(winBufferAdress[1],0) ;
+        buffers[rank] = new CServerBuffer(windows_[rank], winBufferAdress, 0, newSize) ;
         info(100)<<"Context id "<<context->getId()<<" : Receive ChangeBufferSize from client rank "<<rank
-                 <<"  newSize : "<<newSize<<" Address : "<<winAdress[0]<<" & "<<winAdress[1]<<endl ;
+                 <<"  newSize : "<<newSize<<" Address : "<<winBufferAdress[0]<<" & "<<winBufferAdress[1]<<endl ;
       }
       else
@@ -309,8 +305,5 @@
     CEventServer* event;
     
-//    if (context->isProcessingEvent()) return ;
     if (isProcessingEvent_) return ;
-    if (isAttachedModeEnabled())
-      if (!CXios::getDaemonsManager()->isScheduledContext(remoteHashId_)) return ;
 
     it=events.find(currentTimeLine);
@@ -321,5 +314,5 @@
       if (event->isFull())
       {
-        if (!scheduled && !isAttachedModeEnabled()) // Skip event scheduling for attached mode and reception on client side
+        if (!scheduled)
         {
           eventScheduler_->registerEvent(currentTimeLine,hashId);
@@ -327,5 +320,5 @@
           scheduled=true;
         }
-        else if (isAttachedModeEnabled() || eventScheduler_->queryEvent(currentTimeLine,hashId) )
+        else if (eventScheduler_->queryEvent(currentTimeLine,hashId) )
         {
           if (!enableEventsProcessing && isCollectiveEvent(*event)) return ;
@@ -346,5 +339,5 @@
           }
           
-          if (CXios::checkEventSync)
+          if (CXios::checkEventSync && context->getServiceType()!=CServicesManager::CLIENT)
           {
             int typeId, classId, typeId_in, classId_in;
@@ -364,26 +357,16 @@
           }
 
-          if (!isAttachedModeEnabled()) eventScheduler_->popEvent() ;
-          //MPI_Barrier(intraComm) ;
-         // When using attached mode, synchronise the processes to avoid that differents event be scheduled by differents processes
-         // The best way to properly solve this problem will be to use the event scheduler also in attached mode
-         // for now just set up a MPI barrier
-//ym to be check later
-//         if (!eventScheduler_ && CXios::isServer) MPI_Barrier(intraComm) ;
-
-//         context->setProcessingEvent() ;
-         isProcessingEvent_=true ;
-         CTimer::get("Process events").resume();
-         info(100)<<"Context id "<<context->getId()<<" : Process Event "<<currentTimeLine<<" of class "<<event->classId<<" of type "<<event->type<<endl ;
-         dispatchEvent(*event);
-         CTimer::get("Process events").suspend();
-         isProcessingEvent_=false ;
-//         context->unsetProcessingEvent() ;
-         pendingEvent=false;
-         delete event;
-         events.erase(it);
-         currentTimeLine++;
-         scheduled = false;
-         if (isAttachedModeEnabled()) CXios::getDaemonsManager()->unscheduleContext() ;
+          isProcessingEvent_=true ;
+          CTimer::get("Process events").resume();
+          info(100)<<"Context id "<<context->getId()<<" : Process Event "<<currentTimeLine<<" of class "<<event->classId<<" of type "<<event->type<<endl ;
+          eventScheduler_->popEvent() ;
+          dispatchEvent(*event);
+          CTimer::get("Process events").suspend();
+          isProcessingEvent_=false ;
+          pendingEvent=false;
+          delete event;
+          events.erase(it);
+          currentTimeLine++;
+          scheduled = false;
         }
       }
@@ -409,14 +392,10 @@
   void CLegacyContextServer::freeWindows()
   {
-    //if (!isAttachedModeEnabled())
-    //{
-    //  for(auto& it : winComm_)
-    //  {
-    //    int rank = it.first ;
-    //    MPI_Win_free(&windows_[rank][0]);
-    //    MPI_Win_free(&windows_[rank][1]);
-    //    MPI_Comm_free(&winComm_[rank]) ;
-    //  }
-    //}
+    for(auto& it : winComm_)
+    {
+      int rank = it.first ;
+      delete windows_[rank][0];
+      delete windows_[rank][1];
+    }
   }
 
Index: XIOS3/trunk/src/transport/legacy_context_server.hpp
===================================================================
--- XIOS3/trunk/src/transport/legacy_context_server.hpp	(revision 2546)
+++ XIOS3/trunk/src/transport/legacy_context_server.hpp	(revision 2547)
@@ -61,5 +61,5 @@
       std::map<int, StdSize> mapBufferSize_;
       std::map<int,MPI_Comm> winComm_ ; //! Window communicators
-      std::map<int,std::vector<MPI_Win> >windows_ ; //! one sided mpi windows to expose client buffers to servers ; No memory will be attached on server side.
+      std::map<int,std::vector<CWindowDynamic*> >windows_ ; //! one sided mpi windows to expose client buffers to servers ; No memory will be attached on server side.
       bool isProcessingEvent_ ;
       size_t remoteHashId_; //!< the hash is of the calling context client
Index: XIOS3/trunk/src/transport/one_sided_context_client.cpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_context_client.cpp	(revision 2546)
+++ XIOS3/trunk/src/transport/one_sided_context_client.cpp	(revision 2547)
@@ -22,5 +22,5 @@
     \param [in] intraComm_ communicator of group client
     \param [in] interComm_ communicator of group server
-    \cxtSer [in] cxtSer Pointer to context of server side. (It is only used in case of attached mode).
+    \cxtSer [in] cxtSer Pointer to context of server side. (It is only used in case of attached mode --> obsolete ).
     */
     COneSidedContextClient::COneSidedContextClient(CContext* parent, MPI_Comm intraComm_, MPI_Comm interComm_, CContext* cxtSer)
@@ -30,10 +30,9 @@
       
       pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
-      if (isAttachedModeEnabled()) pureOneSided=false ; // no one sided in attach mode
-
-      if (!isAttachedModeEnabled()) MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
+
+      MPI_Intercomm_merge(interComm_,false, &interCommMerged_) ;
       
       MPI_Comm_split(intraComm_,clientRank,clientRank, &commSelf_) ; // for windows
-
+      eventScheduler_ = parent->getEventScheduler() ;  
       timeLine = 1;
     }
@@ -109,16 +108,11 @@
         {
           if (CTimer::get("Blocking time").isSuspended()) CTimer::get("Blocking time").resume() ;
-          callGlobalEventLoop() ;
+          yield() ;
         } 
       }
       if (!CTimer::get("Blocking time").isSuspended()) CTimer::get("Blocking time").suspend() ;
 
-      if (isAttachedModeEnabled()) // couldBuffer is always true in attached mode
-      {
-        while (checkBuffers(ranks)) callGlobalEventLoop() ;
-      
-        CXios::getDaemonsManager()->scheduleContext(hashId_) ;
-        while (CXios::getDaemonsManager()->isScheduledContext(hashId_)) callGlobalEventLoop() ;
-      }
+
+      synchronize() ;
       
       timeLine++;
@@ -137,4 +131,22 @@
      locked_=false ;
    }
+
+   void COneSidedContextClient::yield(void)
+   {
+     locked_=true ;
+     context_->yield() ;
+     locked_=false ;
+   }
+
+   void COneSidedContextClient::synchronize(void)
+   {
+     if (context_->getServiceType()!=CServicesManager::CLIENT)
+     {
+       locked_=true ;
+       context_->synchronize() ;
+       locked_=false ;
+     }    
+   }
+
    /*!
    Make a new buffer for a certain connection to server with specific rank
@@ -271,5 +283,4 @@
   bool COneSidedContextClient::isNotifiedFinalized(void)
   {
-    if (isAttachedModeEnabled()) return true ;
 
     bool finalized = true;
Index: XIOS3/trunk/src/transport/one_sided_context_client.hpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_context_client.hpp	(revision 2546)
+++ XIOS3/trunk/src/transport/one_sided_context_client.hpp	(revision 2547)
@@ -48,4 +48,6 @@
       void eventLoop(void) ;
       void callGlobalEventLoop() ;
+      void yield() ;
+      void synchronize() ;
       bool havePendingRequests(list<int>& ranks) ;
 
@@ -81,4 +83,5 @@
 
       bool locked_ = false ; //!< The context client is locked to avoid recursive checkBuffer
+      shared_ptr<CEventScheduler> eventScheduler_ ;
   };
 }
Index: XIOS3/trunk/src/transport/one_sided_context_server.cpp
===================================================================
--- XIOS3/trunk/src/transport/one_sided_context_server.cpp	(revision 2546)
+++ XIOS3/trunk/src/transport/one_sided_context_server.cpp	(revision 2547)
@@ -42,5 +42,5 @@
     finished=false;
 
-    if (!isAttachedModeEnabled()) MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
+    MPI_Intercomm_merge(interComm_,true,&interCommMerged_) ;
     MPI_Comm_split(intraComm_, intraCommRank, intraCommRank, &commSelf_) ; // for windows
     
@@ -48,5 +48,4 @@
 
     pureOneSided=CXios::getin<bool>("pure_one_sided",false); // pure one sided communication (for test)
-    if (isAttachedModeEnabled()) pureOneSided=false ; // no one sided in attach mode
       
   }
@@ -165,6 +164,4 @@
   
     if (isProcessingEvent_) return ;
-    if (isAttachedModeEnabled())
-      if (!CXios::getDaemonsManager()->isScheduledContext(remoteHashId_)) return ;
 
     auto it=completedEvents_.find(currentTimeLine);
@@ -174,10 +171,10 @@
       if (it->second.nbSenders == it->second.currentNbSenders)
       {
-        if (!scheduled && !isAttachedModeEnabled()) // Skip event scheduling for attached mode and reception on client side
+        if (!scheduled) 
         {
           eventScheduler_->registerEvent(currentTimeLine,hashId);
           scheduled=true;
         }
-        else if (isAttachedModeEnabled() || eventScheduler_->queryEvent(currentTimeLine,hashId) )
+        else if (eventScheduler_->queryEvent(currentTimeLine,hashId) )
         {
           //if (!enableEventsProcessing && isCollectiveEvent(event)) return ;
@@ -198,5 +195,5 @@
           }
 
-          if (!isAttachedModeEnabled()) eventScheduler_->popEvent() ;
+          eventScheduler_->popEvent() ;
 
           isProcessingEvent_=true ;
@@ -214,5 +211,4 @@
           currentTimeLine++;
           scheduled = false;
-          if (isAttachedModeEnabled()) CXios::getDaemonsManager()->unscheduleContext() ;
         }
       }
@@ -235,6 +231,4 @@
   void COneSidedContextServer::freeWindows()
   {
-    //if (!isAttachedModeEnabled())
-    //{
     //  for(auto& it : winComm_)
     //  {
@@ -244,5 +238,4 @@
     //    MPI_Comm_free(&winComm_[rank]) ;
     //  }
-    //}
   }
 
